Subject: Re: ERS tagging
From: Peter Sylvester <[email-masked]>
To: Julien Stern <[email-masked]>
Cc: [email-masked]
Date: Fri, 19 May 2006 19:23:27 +0200
List-Id: <ietf-ltans.imc.org>

Julien Stern wrote:
> Peter,
>
> I guess that smart decoders would read the algorithm identifier
> as an opaque sequence and check if there is something else prior
> to continuing to decode.
>   
in ASN.1 there is no need to create such "smart" (inefficient)  decoders.
The goal of a asn.1 is to allow fast creation and decoding of data.

If one would allow such syntaxes then you would require decoders to
always behave like that. Why would you stop at one level? You could
as well ask that as soon as you are able to find one pattern that matches.

> But at any rate, you are right. I do not have the norm handy
> but I after checking in an ASN.1 book it does seem that the current
> ArchiveTimeStamp syntax is ambiguous.
>   
Yes, ASN.1 specifies for SEQUENCE types

*4.5.1* Where there are one or more consecutive occurrences of 
"ComponentType" that are all marked *OPTIONAL* or *DEFAULT*, the tags of 
those "ComponentType"s and of any immediately following component type 
in the series shall be distinct (see clause 30). If automatic tagging 
was selected, the requirement that tags be distinct applies only after 
automatic tagging has been performed, and will always be satisfied.